extends SubViewportContainer
class_name LabelTexture

signal rendered(image,nIndex : int)

##
# The label won't be set until at least one frame has been rendered. This
# counts the number of rendered frames, allowing the rendered texture to be
# emitted on the second frame.
##
var m_nFrame = 0

##
# This associates the rendered image with something in the object that will
# receive the rendered image. How this is used is up to the receiving object.
# When this class was created, it was intended to associate the rendered image
# with a tab on a image wheel.
##
var m_nIndex = -1

func _ready():
	pass

func _process(delta):
	if m_nFrame > 0:
		rendered.emit($SubViewport.get_texture().get_image(),m_nIndex)
		queue_free()
	m_nFrame += 1

func setIndex(a : int):
	m_nIndex = a

func setText(stText : String):
	$SubViewport/Label.text = stText
	
