##
# Both sides of the flatten cube should have separate numbers, and each
# instance of the flatted cube should have a separate set of numbers.
#
# All instances of the flattened cube share the same set of numbers (the
# final set generated), which is wrong.
#
# Both materials used are set as local to scene, which appears to be ignored
# by Godot 4. The result is the same whether or not the materials are set as
# local to scene.
##
extends Node3D

var m_mesh

var m_aLabels = []

func _ready():
	var labelTexture
	
	m_mesh = $"test/Cube"
		
	for nTab in range(2):
		labelTexture = load("res://scenes/label texture/LabelTexture.tscn").instantiate()
		add_child(labelTexture)
		
		##
		# The Blender base material is index zero.
		# The face materials start at index one.
		##
		labelTexture.setIndex(nTab + 1)
		
		labelTexture.setText(str(randi() % 100))
		labelTexture.rendered.connect(processTextureRendered)
		m_aLabels.append(labelTexture)

func _process(delta):
	rotate(Vector3(0,1,0),deg_to_rad(30 * delta))
	
func setText(nIndex : int,image):
	var mat : StandardMaterial3D = m_mesh.get_active_material(nIndex)
	
	mat.albedo_texture = ImageTexture.create_from_image(image)

func setIndex(nWheelTab : int,stText : String):
	m_aLabels[nWheelTab].setText(stText)
	
func processTextureRendered(image,nIndex : int):
	setText(nIndex,image)
